function result = set_concat(varargin)
% Result-Set = set-concat(Set-#1,Set-#2, ...)
% Concatenates continuous datasets (in time) into Result-Set.
%
%                               Christian Kothe, Swartz Center for Computational Neuroscience, UCSD
%                               2010-03-31


if ~exp_begindef('editing') return; end

% do the concatenation
result = [];
for i=1:length(varargin)
    if isfield(varargin{i},'data') 
        if isempty(result)
            result = varargin{i};
        else
            result = pop_mergeset(result,varargin{i});
        end
    end
end

exp_enddef;
