function eeg = set_picktimes(eeg, ranges)
% Out-Set = set_picktimes(In-Set, Time-Ranges)
%
% In:
%   In-Set      : epoched dataset for which time ranges should be averaged
%
%   Time-Ranges : 2d matrix specifying time ranges which should be selected, averaged,
%                 and emitted as new samples into the resulting dataset
%                 specified as [Range1-Begin Range1-End; Range2-Begin Range2-End, ...]
%
% Out:
%   Out-Set : newly created epoched dataset, whose samples are averages over the supplied time ranges
%
%                       Christian Kothe, Swartz Center for Computational Neuroscience, UCSD
%                       2010-04-01

if ~exp_begindef('editing') return; end

eeg.data = utl_picktimes(eeg.data, (ranges-eeg.xmin) * eeg.srate);

eeg_enddef;
