function [eeg,inds] = set_sortepos(eeg)
% [Out-Set,Indices] = set_sortepos(In-Set)
% Sort epochs in a given data set by their latency; critical for correct chronological cross-validation.
%
% Note:
%   Sorts according to the EEG.epoch.latency field.
%
%                               Christian Kothe, Swartz Center for Computational Neuroscience, UCSD
%                               2010-03-31


inds = [];
if ~exp_begindef('editing') return; end

[x,inds] = sort([eeg.epoch.latency]); %#ok<ASGLU>
eeg = pop_select(eeg,'trial',inds,'sort',0);

exp_enddef;
