function res = exp_set(lhs,rhs) %#ok<STOUT>
% Rule = exp_set(Left-Hand-Side,Right-Hand-Side)
% An assignment expression; can be used inside exp_block or against the global workspace
%
% In:
%   Left-Hand-Side  : the target of the assignment
%   Right-Hand-Side : the expression being assigned
%
% Out:
%   Result        : the assignment expression
%
%                                                     Christian Kothe, Swartz Center for Computational Neuroscience, UCSD
%                                                     2010-05-22

global bcilab;

if ~exp_begindef('symbolic', 'hold','first') return; end

% make an assignment in the global workspace
if ~is_symbol(lhs)
    error('For now, each lhs expression must evaluate to a symbol.'); end
bcilab.workspace.ov.(char(get_function_symbol(lhs))) = rhs;

exp_enddef;

