function res = exp_setdelayed(lhs,rhs) %#ok<STOUT>
% Rule = exp_setdelayed(Left-Hand-Side,Right-Hand-Side)
% A a delayed assignment expression; can be used inside exp_block or against the global workspace
% the right-hand-side will be evaluated every time the left-hand-side is referenced.
%
% In:
%   Left-Hand-Side  : the target of the assignment
%   Right-Hand-Side : the expression being assigned
%
% Out:
%   Result        : the assignment expression
%
%                                                     Christian Kothe, Swartz Center for Computational Neuroscience, UCSD
%                                                     2010-05-22

global bcilab;

if ~exp_begindef('symbolic', 'hold','all') return; end

% make an assignment in the global workspace
if ~is_symbol(lhs)
    error('For now, each lhs expression must evaluate to a symbol.'); end
bcilab.workspace.ov.(char(get_function_symbol(lhs))) = exp_hold(rhs);

exp_enddef;