function [eeg,state] = flt_envelope(eeg,state)
% [Result-Set,State] = flt_envelope(Input-Set,State)
% Compute the signal envelope for a continuous eeg set.
% 
% The envelope of a band-limited signal gives the time course of the power of the signal. It can not be used for online purposes.
%
% In:
%   Input-Set   :   continuous eeg set to be transformed
%
%   State       :   state of the filter from a previous application
%
% Out: 
%   Result-Set  :   transformed, continuous eeg set
%
%   State       :   state of the filter after the application
%
%                           Christian Kothe, Swartz Center for Computational Neuroscience, UCSD
%                           2010-04-18

% register the execution
if ~exp_begindef('filter') return; end

for e=1:size(eeg.data,3)
    eeg.data(:,:,e) = abs(hilbert(eeg.data(:,:,e)'))'; end

state = '<noncausal>';
exp_enddef;