function vis_boxes2(data,xlab,ylab,filename,ticklabels,fontsize)
% vis_boxes(Data,xlab,ylab)
% draws a series of box plots, for papers
%
%                                               Christian Kothe, FG MMS, TU-Berlin
%                                               13.04.2007

if ~exist('fontsize') || isempty(fontsize) fontsize = 15; end


% render it
hold;
%boxplot(data,'symbol','','whisker',100000);
line([0 0]*100,[0 0.5], 'color', 'black');
if iscell(data)
    for i=1:length(data)
        y = i*ones(length(data{i}),1)+randn(length(data{i}),1)*0.05;
        scatter(y,data{i},50,[238,128,62]/255);        
    end
else
    y = repmat(1:size(data,2),[size(data,1),1]);
    y = y+randn(size(y))*0.05;
    scatter(y(:),data(:),50,[238,128,62]/255);
end

if exist('xlab') xlabel(xlab,'FontSize',fontsize); end
if exist('ylab') ylabel(ylab,'FontSize',fontsize); end
ylim([0 0.55]);
grid on;
set(gca,'XTick',1:size(data,2));
set(gca,'FontSize',fontsize);
hold;

figure;

% generate data
%means = 
%x = mvnrnd(means, diag(stddevs.*stddevs), 10000);

if ~exist('ticklabels') || isempty(ticklabels)
    ticklabels = {'A','B','C','D','E','F','G','H'};
end

% render it
boxplot(data,'symbol','','whisker',100000);
if exist('xlab') xlabel(xlab,'FontSize',fontsize+1); end
if exist('ylab') ylabel(ylab,'FontSize',fontsize+1); end
set(gca,'FontSize',fontsize+1);
set(gca,'XTickLabel',{ticklabels{1:size(data,2)}});
ylim([0 0.55]);
grid on;
hold;

if ~isempty(filename)
    save2pdf(filename,gcf);
end