function vis_cspspec(dataset,cla)
% display an averaged spectrogram for all "csp channels"
% In:
%   dataset   : preprocessed dataset containing classidx              
%   cla       : classifier for the dataset

% Author: Matti Gaertner, TU Berlin, 7.12.2009   


datadims = size(dataset.data);
cspdims = size(cla.csp.patterns,1);

for d = 1:cspdims
    cspflt = cla.csp.patterns(d,:);
    data = squeeze(reshape(dataset.data,datadims(1),datadims(2)*datadims(3),1));
    cspfltdata = cspflt*data;
    cspfltdata = reshape(cspfltdata,datadims(2),datadims(3));
    dataset.data(d,:,:) = cspfltdata;
    dataset.chanlocs(d).labels = num2str(d);
end

dims1 = 1:cspdims/2;
dims2 = flipdim(cspdims/2+1:cspdims,2);

figure;
vis_spectrogram(dataset,[{dataset.chanlocs(dims1).labels}; {dataset.chanlocs(dims2).labels}],'local',[],[],[],2);