function vis_diag(x,y,xlab,ylab,fontsize,ticksize,ticksymb)
% vis_diag(x,y,xlab,ylab,fontsize,ticksize)
% do a diagonal accuracy comparison plot, for papers...
%
%                                               Christian Kothe, FG MMS, TU-Berlin
%                                               13.04.2007

if ~exist('fontsize') || isempty(fontsize) fontsize = 15; end
if ~exist('ticksize') || isempty(ticksize) ticksize = 150; end
if ~exist('ticksymb') || isempty(ticksymb) ticksymb = '+'; end

hold;

h=line([0 0.5]*100,[0 0.5]*100, 'color', 'black');set(h,'LineWidth',2)
%set(gca, 'PlotBoxAspectRatioMode','manual');
%set(gca, 'DataAspectRatioMode','manual');
%set(gca, 'CameraViewAngleMode','manual');
xlim([0 50]);
ylim([0 50]);
%h=line([0 0.6]*100,[0 0.6]*100, 'color', 'black');set(h,'LineWidth',2)

h=scatter(x*100,y*100,ticksize,repmat([1 0 0],[length(x) 1]),ticksymb);
set(h,'LineWidth',2)
if exist('xlab') xlabel(xlab,'FontSize',22); end
if exist('ylab') ylabel(ylab,'FontSize',22); end

set(gca,'FontSize',fontsize, 'FontName','Courier');
grid on
hold;