function weights = vis_linearweights(classifier)
% visualize the weights of linear classifiers (as topo plots)
%
%
%                               Christian Kothe, FG MMS, TU-Berlin
%                               21.11.2007


if isfield(classifier,'cla')
    classifier = classifier.cla;
end

if ~isfield(classifier,'chanlocs')
    error('chanlocs are required to display the topo plot');
end


% first, generate the topo data...
channels = length(classifier.chanlocs);
slices = length(classifier.model.model.w)/channels;
topodata = zeros(slices+1,channels);
for i=1:slices
    topodata(i,:) = (classifier.model.model.w(1+(i-1)*channels:i*channels));
end

topodata(end,:) = sum(abs(topodata))/slices; % probably this isn't it yet

weights = topodata(end,:);

total_limits = max(max(abs(topodata)));
limits = [-total_limits total_limits];
%limits = [min(min(topodata)), max(max(topodata))];

nplots = size(topodata,1);
cols = ceil(sqrt(nplots));
rows = ceil(nplots/cols);

for i=1:nplots
    subplot(rows,cols,i);
%    if isfield(classifier.preproc,'tranges')
    vis_topo(topodata(i,:),classifier.chanlocs, limits);
%     vis_topo(topodata(i,:),classifier.chanlocs);
     %vis_topo(topodata(i,:),classifier.chanlocs, [0,max(abs(topodata(i,:)))]);
     
     try
         title(['[' num2str(classifier.preproc.tranges(i,:)) ']' ]);
     catch,end
end

%colormap('cool');