medianIndependentModulatorActivation = [];
iqrIndependentModulatorActivation = [];
for conditionId = 1:15
    conditionId
    conditionLabel{conditionId} = ALLEEG(conditionId).filename(1:end-4);
    independentModulatorForCondition(conditionId) = independent_modulator_activation_on_new_data(ALLEEG(conditionId), independentModulator);
    %independentModulatorForCondition(conditionId).conditionLabel = conditionLabel{conditionId};
    medianIndependentModulatorActivation(conditionId,:) = median(independentModulatorForCondition(conditionId).activation,2);
    iqrIndependentModulatorActivation(conditionId,:) = iqr(independentModulatorForCondition(conditionId).activation,2);
end;


%% load and assign emotion valence

v = load('/data/common1/emotion/EmoValence.mat');
for i=1:length(conditionLabel)
    conditionValence(i) = v.emoval(find(strcmp(v.emos, conditionLabel{i})));
    conditionActiv(i) = v.emoactiv(find(strcmp(v.emos, conditionLabel{i})));    
end;

%% calculate correlation between IMs and valence

for imNumber=1:size(medianIndependentModulatorActivation, 2)
    [t p]= corrcoef([medianIndependentModulatorActivation(:,imNumber), conditionValence']);
    imCorrelationWithValence(imNumber) = t(1,2);
    imCorrelationSignificanceWithValence(imNumber) = p(1,2);
    
    [t p]= corrcoef([medianIndependentModulatorActivation(:,imNumber), conditionActiv']);
    imCorrelationSignificanceWithActiv(imNumber) = p(1,2);
end;

%%

medianICSpectralDecompositionActivation = [];
iqrICSpectralDecompositionActivation = [];

for conditionId = 1:15
    conditionId
    for icId = 1:length(independentModulatorForCondition(1).icSpectralDecomposition)
        medianICSpectralDecompositionActivation(conditionId,icId,:) = median(independentModulatorForCondition(conditionId).icSpectralDecomposition(icId).activation,2);
        iqrICSpectralDecompositionActivation(conditionId,icId,:) = iqr(independentModulatorForCondition(conditionId).icSpectralDecomposition(icId).activation,2);
    end;
end;

%%

for i =1:15
    medianICSpectralDecompositionActivationAll(i,:) = reshape(medianICSpectralDecompositionActivation(i,:,:), 1, []);
    iqrICSpectralDecompositionActivationAll(i,:) = reshape(iqrICSpectralDecompositionActivation(i,:,:), 1, []);
end;

for icImNumber=1:size(medianICSpectralDecompositionActivationAll, 2)
    [t p]= corrcoef([medianICSpectralDecompositionActivationAll(:,icImNumber), conditionValence']);
    icImCorrelationWithValence(icImNumber) = t(1,2);
    icImCorrelationSignificanceWithValence(icImNumber) = p(1,2);
    
    [t p]= corrcoef([medianICSpectralDecompositionActivationAll(:,icImNumber), conditionActiv']);
    icImCorrelationSignificanceWithActiv(icImNumber) = p(1,2);
end;


%% for differences
counter = 0;
activDiff = zeros(size(medianICSpectralDecompositionActivationAll, 2)^2, size(medianICSpectralDecompositionActivationAll, 1));
for i=1:size(medianICSpectralDecompositionActivationAll, 2)
    for j=1:size(medianICSpectralDecompositionActivationAll, 2)
        counter = counter+ 1;
        activDiff(counter,:) = (medianICSpectralDecompositionActivationAll(:,i) - medianICSpectralDecompositionActivationAll(:,j))';
    end;
end;

%%

for icImNumber=1:size(activDiff,1)
    icImNumber
    t = corrcoef([activDiff(icImNumber,:)', conditionValence']);
    icImCorrelationWithValence(icImNumber) = t(1,2);
    
    t = corrcoef([activDiff(icImNumber,:)', conditionActiv']);
    icImCorrelationWithActiv(icImNumber) = t(1,2);
end;

%% find features that differ more across conditions that inside each condition

% for Independent Modulators
desiredVariabilityForIndependentModulators = std(medianIndependentModulatorActivation,1) ./ mean(iqrIndependentModulatorActivation,1);
figure; plot(sort(desiredVariabilityForIndependentModulators,'descend'),'o-');

% for IC spectral modulators
desiredVariabilityForIcSpectralDecomposition  = std(medianICSpectralDecompositionActivationAll,1) ./ mean(iqrICSpectralDecompositionActivationAll,1);
figure; plot(sort(desiredVariabilityForIcSpectralDecomposition,'descend'),'o-');

%% try to regress valence and motional activation using leave one out aaproach

response = cat(1, conditionValence, conditionActiv);
responseLabel = {'Valence' 'Activ'};

eegMeasure = medianIndependentModulatorActivation;
%eegMeasure = cat(2, medianICSpectralDecompositionActivationAll,medianIndependentModulatorActivation);

for i=1:size(response, 2)
    foldConditionId = setdiff(1:size(response, 2), i);    
    foldResponse = response(:,foldConditionId);
    
    
    % select features
    %desiredVariabilityForIndependentModulators = std(medianIndependentModulatorActivation(foldConditionId,:),1) ./ mean(iqrIndependentModulatorActivation(foldConditionId,:),1);
    %selectedFeatureId = find(desiredVariabilityForIndependentModulators > 0.3);
    
    selectedFeatureId = {};
    trainingPredictorMatrix= {};
    testPredictorMatrix = {};
    for j = 1:2
        [c significance] = corr(foldResponse(j,:)', eegMeasure(foldConditionId,:),'type','spearman');
        selectedFeatureId{j} = find(significance < 0.35);
        trainingPredictorMatrix{j} = eegMeasure(foldConditionId, selectedFeatureId{j});
        testPredictorMatrix{j} = eegMeasure(i, selectedFeatureId{j});
        
        % add one for regression
     %   trainingPredictorMatrix{j} = cat(2, trainingPredictorMatrix{j}, ones(size(trainingPredictorMatrix{j},1), 1));
     %   testPredictorMatrix{j} = cat(2, testPredictorMatrix{j}, ones(size(testPredictorMatrix{j},1), 1));
        
        model{j} = regress(foldResponse(j,:)', trainingPredictorMatrix{j});
        estimation(j,i) = testPredictorMatrix{j} * model{j};
      
     %  [model{j},se,pval,inmodel] = stepwisefit(trainingPredictorMatrix{j}, foldResponse(j,:)', 'premove', 0.2, 'penter', 0.1);
      % estimation(j,i) = testPredictorMatrix{j}(inmodel) * model{j}(inmodel);
        
    end;
      
    %b = robustfit(medianIndependentModulatorActivation(foldConditionId,:),foldConditionValence);
end;

figure;
for j=1:2
    subplot(1,2,j);
    plot(estimation(j,:),'ro-');
    hold on;
    plot(response(j,:),'bo-');
    
    [c p] = corr(estimation(j,:)', response(j,:)', 'type','spearman');
    title([responseLabel{j} ' correlation = ' num2str(c)]);
end;

%% calculate windowed activations

windowlength = 5; % in seconds
windwOverlapFactor = 0.5;

medianIndependentModulatorActivationInWindow = [];

for conditionId = 1:15
    conditionId
    conditionLabel{conditionId} = ALLEEG(conditionId).filename(1:end-4);
    independentModulatorForCondition(conditionId) = independent_modulator_activation_on_new_data(ALLEEG(conditionId), independentModulator);
    %independentModulatorForCondition(conditionId).conditionLabel = conditionLabel{conditionId};
    
    for 
    medianIndependentModulatorActivationInWindow(conditionId,:) = median(independentModulatorForCondition(conditionId).activation,2);
    iqrIndependentModulatorActivation(conditionId,:) = iqr(independentModulatorForCondition(conditionId).activation,2);
end;