function plot_single_spectral_template(icSpectralDecomposition, singleTemplateNumber, polarity)
% plot_single_spectral_template(icSpectralDecomposition, singleTemplateNumber, polarity)
% plot a single spectral template with given polarity


if nargin<3
    polarity =1;
end;

plot(icSpectralDecomposition.frequencies, polarity * icSpectralDecomposition.mix(:,singleTemplateNumber), 'linewidth',3);
hold on;
plot(icSpectralDecomposition.frequencies,polarity * icSpectralDecomposition.mix(:,singleTemplateNumber),'.k');
set(gca, 'xtick',[min(icSpectralDecomposition.frequencies) 5 7 10 17 25 50 100]);
xlim([min(icSpectralDecomposition.frequencies) max(icSpectralDecomposition.frequencies)]);
set(gca, 'xscale','log');
xlabel('Freq. (Hz)');
end